library benchpress.src.sample_description_dart;

import 'package:angular2/src/facade/collection.dart'
    show StringMapWrapper, ListWrapper, Map;
import 'package:angular2/di.dart' show bind, OpaqueToken;
import './validator.dart' show Validator;
import './metric.dart' show Metric;
import './sample_options.dart' show Options;

class SampleDescription {
  static get BINDINGS {
    return _BINDINGS;
  }
  String id;
  Map description;
  Map metrics;
  SampleDescription(id, List<Map> descriptions, Map metrics) {
    this.id = id;
    this.metrics = metrics;
    this.description = {};
    ListWrapper.forEach(descriptions, (description) {
      StringMapWrapper.forEach(description, (value, prop) {
        return this.description[prop] = value;
      });
    });
  }
}
var _BINDINGS = [
  bind(SampleDescription).toFactory(
      (metric, id, forceGc, userAgent, validator, defaultDesc, userDesc) {
    return new SampleDescription(id, [
      {'forceGc': forceGc, 'userAgent': userAgent},
      validator.describe(),
      defaultDesc,
      userDesc
    ], metric.describe());
  }, [
    Metric,
    Options.SAMPLE_ID,
    Options.FORCE_GC,
    Options.USER_AGENT,
    Validator,
    Options.DEFAULT_DESCRIPTION,
    Options.SAMPLE_DESCRIPTION
  ]),
  bind(Options.DEFAULT_DESCRIPTION).toValue({}),
  bind(Options.SAMPLE_DESCRIPTION).toValue({})
];
