library benchpress.test.web_driver_extension_spec_dart;

import 'package:angular2/test_lib.dart'
    show ddescribe, describe, it, iit, xit, expect, beforeEach, afterEach;
import 'package:angular2/src/facade/collection.dart' show Map, ListWrapper;
import 'package:angular2/src/facade/lang.dart' show isPresent, StringWrapper;
import 'package:angular2/src/facade/async.dart' show PromiseWrapper;
import 'package:benchpress/benchpress.dart'
    show WebDriverExtension, bind, Injector, Options;

main() {
  createExtension(ids, caps) {
    return new Injector([
      ListWrapper.map(ids, (id) {
        return bind(id).toValue(new MockExtension(id));
      }),
      bind(Options.CAPABILITIES).toValue(caps),
      WebDriverExtension.bindTo(ids)
    ]).asyncGet(WebDriverExtension);
  }
  describe('WebDriverExtension.bindTo', () {
    it('should bind the extension that matches the capabilities', (done) {
      createExtension(['m1', 'm2', 'm3'], {'browser': 'm2'}).then((m) {
        expect(m.id).toEqual('m2');
        done();
      });
    });
    it('should throw if there is no match', (done) {
      PromiseWrapper.catchError(createExtension(['m1'], {'browser': 'm2'}),
          (err) {
        expect(isPresent(err)).toBe(true);
        done();
      });
    });
  });
}
class MockExtension extends WebDriverExtension {
  String id;
  MockExtension(id) : super() {
    this.id = id;
  }
  bool supports(Map capabilities) {
    return StringWrapper.equals(capabilities['browser'], this.id);
  }
}
